﻿using Bulldozer.DrawningObjects;
using Bulldozer.Entities;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bulldozer.Generics
{
    internal class BulldozerCompareByColor : IComparer<DrawningBulldozer?>
    {
        public int Compare(DrawningBulldozer? x, DrawningBulldozer? y)
        {
            if (x == null || x.EntityTractor == null)
                throw new ArgumentNullException(nameof(x));

            if (y == null || y.EntityTractor == null)
                throw new ArgumentNullException(nameof(y));

            if (x.EntityTractor.MainColor.Name != y.EntityTractor.MainColor.Name)
            {
                return x.EntityTractor.MainColor.Name.CompareTo(y.EntityTractor.MainColor.Name);
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                if (x is EntityBulldozer)
                    return -1;
                else
                    return 1;
            }
            if (x.GetType().Name == y.GetType().Name && x is DrawningFastBulldozer)
            {
                EntityFastBulldozer EntityX = (EntityFastBulldozer)x.EntityTractor;
                EntityFastBulldozer EntityY = (EntityFastBulldozer)y.EntityTractor;
                if (EntityX.OptionalColor.Name != EntityY.OptionalColor.Name)
                {
                    return EntityX.OptionalColor.Name.CompareTo(EntityY.OptionalColor.Name);
                }
            }
            var speedCompare = x.EntityTractor.Speed.CompareTo(y.EntityTractor.Speed);

            if (speedCompare != 0)
                return speedCompare;

            return x.EntityTractor.Weight.CompareTo(y.EntityTractor.Weight);
        }
    }
}
