﻿using Bulldozer.DrawningObjects;
using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bulldozer.Generics
{
    internal class BulldozerCompareByType : IComparer<DrawningBulldozer?>
    {
        public int Compare(DrawningBulldozer? x, DrawningBulldozer? y)
        {
            if (x == null || x.EntityTractor == null)
                throw new ArgumentNullException(nameof(x));

            if (y == null || y.EntityTractor == null)
                throw new ArgumentNullException(nameof(y));

            if (x.GetType().Name != y.GetType().Name)
            {
                return x.GetType().Name.CompareTo(y.GetType().Name);
            }
            var speedCompare = x.EntityTractor.Speed.CompareTo(y.EntityTractor.Speed);

            if (speedCompare != 0)
                return speedCompare;

            return x.EntityTractor.Weight.CompareTo(y.EntityTractor.Weight);
        }
    }
}
