﻿using Bulldozer.DrawningObjects;
using Bulldozer.Entities;
using System;
using System.Collections.Generic;
using System.Diagnostics.CodeAnalysis;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace Bulldozer.Generics
{
    internal class DrawiningBulldozerEqutables : IEqualityComparer<DrawningBulldozer?>
    {
        public bool Equals(DrawningBulldozer? x, DrawningBulldozer? y)
        {
            if (x == null || x.EntityTractor == null)
            {
                throw new ArgumentNullException(nameof(x));
            }
            if (y == null || y.EntityTractor == null)
            {
                throw new ArgumentNullException(nameof(y));
            }
            if (x.GetType().Name != y.GetType().Name)
            {
                return false;
            }
            if (x.EntityTractor.Speed != y.EntityTractor.Speed)
            {
                return false;
            }
            if (x.EntityTractor.Weight != y.EntityTractor.Weight)
            {
                return false;
            }
            if (x.EntityTractor.MainColor != y.EntityTractor.MainColor)
            {
                return false;
            }
            if (x is EntityFastBulldozer && y is EntityFastBulldozer)
            {
                EntityFastBulldozer EntityX = (EntityFastBulldozer)x.EntityTractor;
                EntityFastBulldozer EntityY = (EntityFastBulldozer)y.EntityTractor;
                if (EntityX.OptionalColor != EntityY.OptionalColor)
                    return false;
                if (EntityX.Covsh != EntityY.Covsh)
                    return false;
                if (EntityX.Rearbucket != EntityY.Rearbucket)
                    return false;
            }
            return true;
        }
        public int GetHashCode([DisallowNull] DrawningBulldozer obj)
        {
            return obj.GetHashCode();
        }
    }
}
